/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-01 at 19:46:24 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.admin.directory.model;

/**
 * JSON template for Mobile Device resource in Apps Directory API.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Admin Directory API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class MobileDevice extends com.google.api.client.json.GenericJson {

  /**
   * List of applications installed on Mobile Device
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Applications> applications;

  static {
    // hack to force ProGuard to consider Applications used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Applications.class);
  }

  /**
   * Mobile Device serial number (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String deviceId;

  /**
   * List of owner user's email addresses (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> email;

  /**
   * Date and time the device was first synchronized with the policy settings in the Google Apps
   * administrator control panel (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime firstSync;

  /**
   * Mobile Device Hardware Id (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String hardwareId;

  /**
   * Kind of resource this is.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Date and time the device was last synchronized with the policy settings in the Google Apps
   * administrator control panel (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime lastSync;

  /**
   * Name of the model of the device
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String model;

  /**
   * List of owner user's names (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> name;

  /**
   * Name of the mobile operating system
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String os;

  /**
   * Unique identifier of Mobile Device (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String resourceId;

  /**
   * Status of the device (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String status;

  /**
   * The type of device (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String type;

  /**
   * Mobile Device user agent
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String userAgent;

  /**
   * List of applications installed on Mobile Device
   * @return value or {@code null} for none
   */
  public java.util.List<Applications> getApplications() {
    return applications;
  }

  /**
   * List of applications installed on Mobile Device
   * @param applications applications or {@code null} for none
   */
  public MobileDevice setApplications(java.util.List<Applications> applications) {
    this.applications = applications;
    return this;
  }

  /**
   * Mobile Device serial number (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getDeviceId() {
    return deviceId;
  }

  /**
   * Mobile Device serial number (Read-only)
   * @param deviceId deviceId or {@code null} for none
   */
  public MobileDevice setDeviceId(java.lang.String deviceId) {
    this.deviceId = deviceId;
    return this;
  }

  /**
   * List of owner user's email addresses (Read-only)
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getEmail() {
    return email;
  }

  /**
   * List of owner user's email addresses (Read-only)
   * @param email email or {@code null} for none
   */
  public MobileDevice setEmail(java.util.List<java.lang.String> email) {
    this.email = email;
    return this;
  }

  /**
   * Date and time the device was first synchronized with the policy settings in the Google Apps
   * administrator control panel (Read-only)
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getFirstSync() {
    return firstSync;
  }

  /**
   * Date and time the device was first synchronized with the policy settings in the Google Apps
   * administrator control panel (Read-only)
   * @param firstSync firstSync or {@code null} for none
   */
  public MobileDevice setFirstSync(com.google.api.client.util.DateTime firstSync) {
    this.firstSync = firstSync;
    return this;
  }

  /**
   * Mobile Device Hardware Id (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getHardwareId() {
    return hardwareId;
  }

  /**
   * Mobile Device Hardware Id (Read-only)
   * @param hardwareId hardwareId or {@code null} for none
   */
  public MobileDevice setHardwareId(java.lang.String hardwareId) {
    this.hardwareId = hardwareId;
    return this;
  }

  /**
   * Kind of resource this is.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Kind of resource this is.
   * @param kind kind or {@code null} for none
   */
  public MobileDevice setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Date and time the device was last synchronized with the policy settings in the Google Apps
   * administrator control panel (Read-only)
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getLastSync() {
    return lastSync;
  }

  /**
   * Date and time the device was last synchronized with the policy settings in the Google Apps
   * administrator control panel (Read-only)
   * @param lastSync lastSync or {@code null} for none
   */
  public MobileDevice setLastSync(com.google.api.client.util.DateTime lastSync) {
    this.lastSync = lastSync;
    return this;
  }

  /**
   * Name of the model of the device
   * @return value or {@code null} for none
   */
  public java.lang.String getModel() {
    return model;
  }

  /**
   * Name of the model of the device
   * @param model model or {@code null} for none
   */
  public MobileDevice setModel(java.lang.String model) {
    this.model = model;
    return this;
  }

  /**
   * List of owner user's names (Read-only)
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getName() {
    return name;
  }

  /**
   * List of owner user's names (Read-only)
   * @param name name or {@code null} for none
   */
  public MobileDevice setName(java.util.List<java.lang.String> name) {
    this.name = name;
    return this;
  }

  /**
   * Name of the mobile operating system
   * @return value or {@code null} for none
   */
  public java.lang.String getOs() {
    return os;
  }

  /**
   * Name of the mobile operating system
   * @param os os or {@code null} for none
   */
  public MobileDevice setOs(java.lang.String os) {
    this.os = os;
    return this;
  }

  /**
   * Unique identifier of Mobile Device (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getResourceId() {
    return resourceId;
  }

  /**
   * Unique identifier of Mobile Device (Read-only)
   * @param resourceId resourceId or {@code null} for none
   */
  public MobileDevice setResourceId(java.lang.String resourceId) {
    this.resourceId = resourceId;
    return this;
  }

  /**
   * Status of the device (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getStatus() {
    return status;
  }

  /**
   * Status of the device (Read-only)
   * @param status status or {@code null} for none
   */
  public MobileDevice setStatus(java.lang.String status) {
    this.status = status;
    return this;
  }

  /**
   * The type of device (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getType() {
    return type;
  }

  /**
   * The type of device (Read-only)
   * @param type type or {@code null} for none
   */
  public MobileDevice setType(java.lang.String type) {
    this.type = type;
    return this;
  }

  /**
   * Mobile Device user agent
   * @return value or {@code null} for none
   */
  public java.lang.String getUserAgent() {
    return userAgent;
  }

  /**
   * Mobile Device user agent
   * @param userAgent userAgent or {@code null} for none
   */
  public MobileDevice setUserAgent(java.lang.String userAgent) {
    this.userAgent = userAgent;
    return this;
  }

  @Override
  public MobileDevice set(String fieldName, Object value) {
    return (MobileDevice) super.set(fieldName, value);
  }

  @Override
  public MobileDevice clone() {
    return (MobileDevice) super.clone();
  }

  /**
   * Model definition for MobileDeviceApplications.
   */
  public static final class Applications extends com.google.api.client.json.GenericJson {

    /**
     * Display name of application
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String displayName;

    /**
     * Package name of application
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String packageName;

    /**
     * List of Permissions for application
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.util.List<java.lang.String> permission;

    /**
     * Version code of application
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer versionCode;

    /**
     * Version name of application
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String versionName;

    /**
     * Display name of application
     * @return value or {@code null} for none
     */
    public java.lang.String getDisplayName() {
      return displayName;
    }

    /**
     * Display name of application
     * @param displayName displayName or {@code null} for none
     */
    public Applications setDisplayName(java.lang.String displayName) {
      this.displayName = displayName;
      return this;
    }

    /**
     * Package name of application
     * @return value or {@code null} for none
     */
    public java.lang.String getPackageName() {
      return packageName;
    }

    /**
     * Package name of application
     * @param packageName packageName or {@code null} for none
     */
    public Applications setPackageName(java.lang.String packageName) {
      this.packageName = packageName;
      return this;
    }

    /**
     * List of Permissions for application
     * @return value or {@code null} for none
     */
    public java.util.List<java.lang.String> getPermission() {
      return permission;
    }

    /**
     * List of Permissions for application
     * @param permission permission or {@code null} for none
     */
    public Applications setPermission(java.util.List<java.lang.String> permission) {
      this.permission = permission;
      return this;
    }

    /**
     * Version code of application
     * @return value or {@code null} for none
     */
    public java.lang.Integer getVersionCode() {
      return versionCode;
    }

    /**
     * Version code of application
     * @param versionCode versionCode or {@code null} for none
     */
    public Applications setVersionCode(java.lang.Integer versionCode) {
      this.versionCode = versionCode;
      return this;
    }

    /**
     * Version name of application
     * @return value or {@code null} for none
     */
    public java.lang.String getVersionName() {
      return versionName;
    }

    /**
     * Version name of application
     * @param versionName versionName or {@code null} for none
     */
    public Applications setVersionName(java.lang.String versionName) {
      this.versionName = versionName;
      return this;
    }

    @Override
    public Applications set(String fieldName, Object value) {
      return (Applications) super.set(fieldName, value);
    }

    @Override
    public Applications clone() {
      return (Applications) super.clone();
    }

  }

}
